
/*
				---------------------------------------
				PowerTerm (c) 1992-94  Byron D Copeland
					  All Rights Reserved.
				---------------------------------------

*/

#include <stdio.h>
#include <ctype.h>

char *lstrip( char *s );
void tstrip( char *s );
unsigned int strln( char *s );
void setstrng( char *s, char c, unsigned int len );
void cpstrngn( char *to, char *fro, unsigned int len );
char *stupr( char *s );


/********************************************************************/
/*  Strip Leading spaces from input line.                           */
/********************************************************************/

char *lstrip(char *s)
{
	char 	*t;

	t = s;
	while( *t == ' ' ) t++;
	return( t );
}

/********************************************************************/
/*  Strip trailing spaces from a text line.                         */
/********************************************************************/

void tstrip(char *str)
{
	unsigned int z;

	for ( z = strln( str ) - 1; str[z] == ' ' && z >= 0; z-- );
	str[z+1] = '\0';
}

/*---------------------------------------------------------------------
---------------------------------------------------------------------*/

unsigned int strln(char *s)
{
   unsigned int i = 0;
   char 	*p;

   p = s;
   while ( *p++ ) i++;
   return( i );
}


/*---------------------------------------------------------------------
---------------------------------------------------------------------*/

void setstrng( char *s, char c, unsigned int len )
{
	unsigned int 	i = 0;
	char  		*p;

	p = s;
	while( i++ < len ) *p++ = c;
	*p = '\0';
}

/*---------------------------------------------------------------------
---------------------------------------------------------------------*/

void cpstrngn( char *to, char *fro, unsigned int len )
{
	char 		*p;
	char		*pp;
	unsigned int 	i = 0;

	p = to;
	pp = fro;

	while ( ( *pp ) && ( i++ < len ) )
		*p++ = *pp++;
	*p = '\0';
}

char *stupr( char *s )
{
	char	*p;

	p = s;

	while( *p )	{
		*p = toupper( *p );
		p++;
	}
	return( s );
}
