
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			 All Rights Reserved.
		---------------------------------------

*/

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <conio.h>

#define 	ESC 	0x1B
#define 	mTTY 	  0x00
#define 	mVT52 	  0x01
#define 	mVT102 	  0x02
#define 	mANSI 	  0x03
#define		mAVATAR   0x04
#define		mTEK4107C 0x05
#define		mIBM3101  0x07

#define 	FALSE 	0
#define 	TRUE   	(!FALSE)

#define cr3101          "\033Y%c%c\r\0"         // Cursor Report
#define resp1		"\0336@@\r\0"		// Response 1
#define resp2 		"\0337AC\r\0"		// Response 2

extern char *buff;
extern int            	VideoSeg;
extern int            	VTc, VTr, VTa, VTwt, VTwb;


extern int		NUMLOCK, LFON;
extern unsigned int	EmuMode;

static int		TFlag = 0;
static int		TFlag1 = 0;
static int		TFp[10];
static int		atr;
static int            	SVTr, SVTc, SVTa, PrtFlag, fc;
static int 	       	lc, rw, cl, savch;

void ProcessI3101(int c);

/*------------------------------------------------------------------------
-------------------------------------------------------------------------*/

void ProcessI3101(int c)
{
  static int i, j;
  static unsigned int atr;

  c &= 0x00ff;
  switch(TFlag)  {
	case 0:                            // Is TFlag = 0?
		if (c==ESC)  {
			for (TFlag1=0;TFlag1<10;TFlag1++)
				TFp[TFlag1]=0;
			TFlag=1;
			TFlag1=0;
			return;
		}
		switch(c)  {
			case 0: ScreenCharOut(' '); break;
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
				ScreenCharOut(c);
				break;
			case 7:
				Beep(300);
				break;
			case 8:
				if (VTc>1)  {
					VTc--;
				}
				break;
			case 9:                                              // HT ^I
				for (j=0;j<8;j++)  {
					VTc++;
				}
				break;
			case 10:
				if (++VTr > VTwb)  {
					VTr--;
					ScrollWindowUp(1);
				}
				break;
			case 11:
				ScreenCharOut(c);
				break;
			case 12:                                  // Form Feed
				EraseScreen(VTwt,1,VTwb,80);
				VTc=1;
				VTr=1;
				break;
			case 13:
				VTc=1;
				if ( LFON )	{
					if (++VTr > VTwb)  {
						VTr--;
						ScrollWindowUp(1);
					}
				}
				break;
			case 14:
			case 15:
			case 16:
			case 17:
			case 18:
			case 19:
			case 20:
			case 21:
			case 22:
			case 23:
			case 24:
			case 26:
			case 27:
				for (TFlag1=0;TFlag1<10;TFlag1++)
					TFp[TFlag1]=0;
				TFlag=1;
				TFlag1=0;
				return;
			case 28:
			case 29:
			case 30:
			case 31:
			default:
				ScreenCharOut(c);
				break;
	}
	break;
    case 1:                            // Is TFlag = 1?
	switch(c)  {
		case 27:
			return;
		case '0':       		// Tabset
		case '1':			// Tabclr
		case '2':
		case '3':
		case '4':
			break;
		case '5':
			sprintf(buff,cr3101,(VTr+31),(VTc+31));
			SerialString(buff);
			break;
		case '6':
			SerialString(resp1);
			break;
		case '7':
			SerialString(resp2);
			break;
		case '8':
		case '9':
			break;
		case 'A':
			if (TFp[0]==0) TFp[0]=1;
			while(TFp[0]-- > 0)
				if (VTr>VTwt)  VTr--;
			break;
		case 'B':
			if (TFp[0]==0) TFp[0]=1;
			while(TFp[0]-- > 0)
				if (VTr<VTwb)  VTr++;
			break;
		case 'C':
			if (TFp[0]==0) TFp[0]=1;
			while(TFp[0]-- > 0)
				if (VTc<80)  VTc++;
			break;
		case 'D':
			if (TFp[0]==0) TFp[0]=1;
			while(TFp[0]-- > 0)
				if (VTc>1)  VTc--;
			break;
		case 'E':
			break;
		case 'H':
			VTr=VTwt;
			VTc=1;
			break;
		case 'I':
			EraseScreen(VTr,VTc,VTr,80); break;
		case 'J':
			 EraseScreen(VTr,VTc,VTwb,80); break;
		case 'K':
			 EraseScreen(VTwt,1,VTwb,80);
			 VTr=VTwt;
			 VTc=1;
			 break;
		case 'L':
			 EraseScreen(VTwt,1,VTwb,80);
			 VTr=VTwt;
			 VTc=1;
			 break;
		case 'N':
		case 'O':
		case 'P':
		case 'Q':
		case 'S':
		case 'U':
		case 'V':
		case 'W':
			break;

		case 'X':
			TFlag=2;
			TFlag1=0;
			return;
		case 'Y':
			TFlag=2;
			TFlag1=0;
			return;
		case 'Z':
		case ':':
		case ';':
			break;
		default:
			ScreenCharOut(ESC);
			ScreenCharOut(c);
			break;
	}
	TFlag=0;
	break;

    case 2:                     // Is TFlag = 2?
	rw=(c-31);
	TFlag=3;
	return;

    case 3:
	VTr=rw;
	VTc=(c-31);
	TFlag=0;
	break;

  }
}

