/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			 All Rights Reserved.
		---------------------------------------

*/


/*-----------------------------------------------------------------------
   Module PCKEYS.H - Header file used by most Powerterm modules to
		      define all keys.
------------------------------------------------------------------------*/



/* Define PC Scan Codes.  */



#define SPECIALKEY  0
#define BS          8
#define TAB         9
#define LF         10
#define CR         13
#define STAB       15
#define ALTQ       16
#define ALTW	   17
#define ALTE       18
#define ALTR       19
#define ALTT       20
#define ALTY       21
#define ALTU	   22
#define ALTI	   23
#define ALTO	   24
#define CTLX	   24
#define ALTP	   25
#define ESCAPE     27
#define ALTA	   30
#define ALTS	   31
#define SPACE      32
#define ALTD       32
#define ALTF       33
#define ALTG	   34
#define ALTH       35
#define ALTJ	   36
#define ALTK       37
#define ALTL       38
#define ALTZ	   44
#define ALTX       45
#define ALTC	   46
#define ALTV	   47
#define ALTB       48
#define ALTN       49
#define ALTM  	   50
#define SHFDN      50
#define SHFPGDN    51
#define SHFUP      56
#define SHFPGUP    57
#define F1         59
#define F2         60
#define F3         61
#define F4         62
#define F5         63
#define F6         64
#define F7         65
#define F8         66
#define F9         67
#define F10        68
#define HOME       71
#define UP         72
#define PGUP       73
#define LEFT       75
#define RIGHT      77
#define END        79
#define DN         80
#define PGDN       81
#define INS        82
#define DELETE     83
#define F13        84
#define F14        85
#define F15        86
#define F16        87
#define F17        88
#define F18        89
#define F19        90
#define F20        91
#define F21        92
#define F22        93
#define CF1	   94
#define CF2	   95
#define CF3	   96
#define CF4        97
#define CF5        98
#define CF6	   99
#define CF7	   100
#define CF8	   101
#define CF9	   102
#define CF10	   103
#define AF1	   104
#define AF2	   105
#define AF3	   106
#define AF4        107
#define AF5        108
#define AF6	   109
#define AF7	   110
#define AF8	   111
#define AF9	   112
#define AF10	   113
#define CTLLEFT    115
#define CTLRIGHT   116
#define CTLEND     117
#define ALT1	   120
#define ALT2	   121
#define ALT3	   122
#define ALT4	   123
#define ALT5	   124
#define ALT6	   125
#define ALT7	   126
#define ALT8	   127
#define ALT9       128
#define ALT0	   129
#define ALT_EQ	   131
#define F11        133
#define F12        134
#define F23        135
#define F24        136
#define CF11       137
#define CF12       138
#define AF11       139
#define AF12       140
#define CTLDEL     147





 
