
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			  All Rights Reserved.
		---------------------------------------


		String Edit Functions for data entry.

*/

#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <dos.h>

#include "fsvlib.h"
#include "pckeys.h"

#define FALSE 	0
#define TRUE 	(!FALSE)

extern char 	*buff;
extern int 	FnChk, MacChk;
extern int	PRECCHG;

unsigned char	C_Scan_Start;
unsigned char	C_Scan_End;

extern int		UPPERONLY;

char 		*BadFileName="+=||[];\""", ";
char 		*BadFileName2="+=||[];\""",. ";

void EditStringValue( char *strng, unsigned int len, unsigned int Row,
			unsigned int Col, char *EBuf,
			unsigned int Attr1, unsigned int Attr2,
			unsigned int Attr3 );
void EditIntValue( int *Val, unsigned int len, unsigned int Row,
			unsigned int Col, char *EBuf, unsigned int max,
			unsigned int Attr1, unsigned int Attr2,
			unsigned int Attr3 );

void EditHexValue( char *strng, unsigned int len, unsigned int Row,
			unsigned int Col, char *EBuf,
			unsigned int Attr1, unsigned int Attr2,
			unsigned int Attr3 );

/*-----------------------------------------------------------------------
------------------------------------------------------------------------*/

void EditStringValue( char *strng, unsigned int len, unsigned int Row,
			unsigned int Col, char *EBuf,
			unsigned int Attr1, unsigned int Attr2,
			unsigned int Attr3 )
{
	union REGS 	er;
	int 		ESVQUIT = FALSE;
	int 		INSMODE = FALSE;
	unsigned int 	SIdx;
	unsigned int 	WrkCol;
	int		i;
	int		j;
	int		ch;
	int		key;
	char 		*p;
	char		*pp;

	CursorOn();
	fswrite( EBuf, Row, Col, Attr1 );
	fswrite( strng, Row, Col, Attr2 );
	SIdx = strlen( strng );
	WrkCol = Col + strln( strng );
	gotoxy( WrkCol, Row );
	do	{
		kbflush();
		if ( SIdx == len )  {
			SIdx = 0;
			WrkCol = Col;
			gotoxy( WrkCol, Row );
		}
		WaitForKeyPress();
		ch = getch();
		if ( ch == ESCAPE )  {        // Do nothing for this key.
			Beep( 250 );
			continue;
		}
		else
		if ( ch == SPECIALKEY )  {   //  Must get another key waiting
			key = getch();
			if ( key == HOME )  {
				SIdx = 0;
				WrkCol = Col;
			}
			else
			if (key == END)  {
				SIdx = strln( strng );
				WrkCol = Col + ( strln( strng ) );
			}
			else
			if ( key == DELETE )  {
				PRECCHG = TRUE;
				p = &strng[SIdx];
				if ( !p )  {
					Beep( 250 );
					continue;
				}
				pp = &strng[SIdx+1];
				while( *pp )  {
					*p++ = *pp++;
				}
				*p = '\0';
				fswrite( EBuf, Row, Col, Attr1 );
				fswrite( strng, Row, Col, Attr2 );
			}
			else
			if ( key == INS )  {               // Toggle insert mode
				if ( INSMODE )  {
					INSMODE = FALSE;
					er.h.ah = 0x01;
					er.h.ch = 0x06;
					er.h.cl = 0x07;
					int86( 0x10, &er, &er );
/*					fswrite("   ",25,75,Black+LightGrayBG);	*/
				}
				else  {
					er.h.ah = 0x01;
					er.h.ch = 0x00;
					er.h.cl = 0x07;
					int86( 0x10, &er, &er );
					INSMODE = TRUE;
/*					fswrite("INS",25,75,Yellow+BlueBG);	*/
				}
			}
			else
			if ( key == LEFT )  {		// Left arrow
				if ( SIdx == 0 )  {
					SIdx = ( strln( strng ) );
					WrkCol = Col + ( strln( strng ) );
				}
				else  {
					SIdx -= 1;
					WrkCol -= 1;
				}
			}
			else
			if ( key == RIGHT )  {		// Right arrow
				if ( SIdx == strln( strng ) )  {
					SIdx = 0;
					WrkCol = Col;
				}
				else  {
					SIdx += 1;
					WrkCol += 1;
				}
			}
		}
		else
		if ( ch == CR )  {
			if ( FnChk )	{
				if ( ( pp = strpbrk( strng, BadFileName ) ) != NULL )	{
					Beep( 600 );
					continue;
				}
				else	{
					setstrng( EBuf, ' ', len );
					fswrite( EBuf, Row, Col, Attr3 );
					fswrite( strng, Row, Col, Attr3 );
					ESVQUIT = TRUE;
				}
			}
			else
			if ( MacChk )	{
				if ( ( pp = strpbrk( strng, BadFileName2 ) ) != NULL )	{
					Beep( 600 );
					continue;
				}
				else	{
					setstrng( EBuf, ' ', len );
					fswrite( EBuf, Row, Col, Attr3 );
					fswrite( strng, Row, Col, Attr3 );
					ESVQUIT = TRUE;
				}
			}
			else	{
				setstrng( EBuf, ' ', len );
				fswrite( EBuf, Row, Col, Attr3 );
				fswrite( strng, Row, Col, Attr3 );
				ESVQUIT = TRUE;
			}
		}
		else
		if ( ch == TAB )  {
			if ( FnChk )	{
				if ( ( pp = strpbrk( strng, BadFileName ) ) != NULL )	{
					Beep( 600 );
					continue;
				}
				else	{
					setstrng( EBuf, ' ', len );
					fswrite( EBuf, Row, Col, Attr3 );
					fswrite( strng, Row, Col, Attr3 );
					ESVQUIT = TRUE;
				}
			}
			else
			if ( MacChk )	{
				if ( ( pp = strpbrk( strng, BadFileName2 ) ) != NULL )	{
					Beep( 600 );
					continue;
				}
				else	{
					setstrng( EBuf, ' ', len );
					fswrite( EBuf, Row, Col, Attr3 );
					fswrite( strng, Row, Col, Attr3 );
					ESVQUIT = TRUE;
				}
			}
			else	{
				setstrng( EBuf, ' ', len );
				fswrite( EBuf, Row, Col, Attr3 );
				fswrite( strng, Row, Col, Attr3 );
				ESVQUIT = TRUE;
			}
		}
		else
		if ( ch == BS )  {			//  Backspace
			if ( SIdx == 0 )  {
				Beep( 250 );
				continue;
			}
			PRECCHG = TRUE;
			p = &strng[SIdx-1];
			pp = &strng[SIdx];
			while( *pp )  {
				*p++ = *pp++;
			}
			*p = '\0';
			fswrite( EBuf, Row, Col, Attr1 );
			fswrite( strng, Row, Col, Attr2 );
			SIdx -= 1;
			WrkCol -= 1;
		}
		else  {
			if ( INSMODE )  {
				if ( strln( strng ) == len )  {
					Beep( 250 );
					continue;
				}
				p = buff;
				for( i = 0; i < len; i++ ) *p++ = '\0';
				p = &strng[SIdx];
				pp = buff;
				while( *p ) {
					*pp++ = *p++;
				}
				PRECCHG = TRUE;
				strng[SIdx] = ( UPPERONLY ) ? toupper( ch ) : ch;
				SIdx += 1;
				pp = buff;
				p = &strng[SIdx];
				while( *pp )  {
					*p++ = *pp++;
				}
				WrkCol += 1;
				fswrite( strng, Row, Col, Attr2 );
			}
			else  {
				PRECCHG = TRUE;
				strng[SIdx] = ( UPPERONLY ) ? toupper( ch ) : ch;
				SIdx += 1;
				WrkCol += 1;
				fswrite( strng, Row, Col, Attr2 );
			}
		}
		gotoxy( WrkCol, Row );
	}  while ( !ESVQUIT );
	p = &strng[strln( strng ) -1]; 	//  Get rid
	while( *p == ' ' ) *p-- = '\0';	//  of trailing blanks
	p = &strng[strln( strng )];
	i = strln( strng );
	for ( j = i; j < len; j++ )
		*p++ = '\0';
	if ( INSMODE )  {
		INSMODE = FALSE;
		er.h.ah = 0x01;
		er.h.ch = 0x06;
		er.h.cl = 0x07;
		int86( 0x10, &er, &er );
	}
	CursorOff();
	return;
}

/*-----------------------------------------------------------------------
------------------------------------------------------------------------*/

void EditIntValue( int *Val, unsigned int len, unsigned int Row,
			unsigned int Col, char *EBuf, unsigned int max,
			unsigned int Attr1, unsigned int Attr2,
			unsigned int Attr3 )
{
	union REGS 	er;
	int 		ESVQUIT = FALSE;
	int 		INSMODE = FALSE;
	int		i;
	int		j;
	int		ch;
	int		key;
	unsigned int 	SIdx;
	unsigned int 	WrkCol;
	char 		*p;
	char		*pp;
	char 		wrkbuf[20]="\0";
	int		TmpVal;

	CursorOn();
	fswrite( EBuf, Row, Col, Attr1 );
	itoa( ( *Val ), wrkbuf, 10 );
	fswrite( wrkbuf, Row, Col, Attr2 );
	SIdx = strlen( wrkbuf );
	WrkCol = Col + strlen( wrkbuf );
	gotoxy( WrkCol, Row );
	do	{
		kbflush();
		if ( SIdx == len )  {
			SIdx = 0;
			WrkCol = Col;
			gotoxy( WrkCol, Row );
		}
		WaitForKeyPress();
		ch = getch();
		if ( ch == ESCAPE )  {        // Do nothing for this key.
		  Beep( 250 );
		  continue;
		}
		else
		if ( ch == SPECIALKEY )  {   //  Must get another key waiting
			key = getch();
			if ( key == HOME )  {
				SIdx = 0;
				WrkCol = Col;
			}
			else
			if ( key == END )  {
				SIdx = strlen( wrkbuf );
				WrkCol = Col + ( strlen( wrkbuf ) );
			}
			else
			if ( key == DELETE )  {
				p = &wrkbuf[SIdx];
				if ( !p )  {
					Beep( 250 );
					continue;
				}
				pp = &wrkbuf[SIdx+1];
				while( *pp )  {
					*p++ = *pp++;
				}
				*p= '\0';
				fswrite( EBuf, Row, Col, Attr1 );
				fswrite( wrkbuf, Row, Col, Attr2 );
			}
			if ( key == INS )  {               // Toggle insert mode
				if ( INSMODE )  {
					INSMODE = FALSE;
					er.h.ah = 0x01;
					er.h.ch = 0x06;
					er.h.cl = 0x07;
					int86( 0x10, &er, &er );
/*					fswrite("   ",25,75,White+BlueBG);	*/
				}
				else  {
					INSMODE = TRUE;
					er.h.ah = 0x01;
					er.h.ch = 0x00;
					er.h.cl = 0x07;
					int86( 0x10, &er, &er );
/*					fswrite("INS",25,75,Black+LightGrayBG);	*/
				}
			}
			else
			if ( key == LEFT )  {		// Left arrow
				if ( SIdx == 0 )  {
					SIdx = ( strlen( wrkbuf ) );
					WrkCol = Col + ( strlen( wrkbuf ) );
				}
				else  {
					SIdx -= 1;
					WrkCol -= 1;
				}
			}
			else
			if ( key == RIGHT )  {		// Right arrow
				if ( SIdx == strlen( wrkbuf ) )  {
					SIdx = 0;
					WrkCol = Col;
				}
				else  {
					SIdx += 1;
					WrkCol += 1;
				}
			}
		}
		else
		if ( ch == CR )  {
			TmpVal = atoi( wrkbuf );
			if ( TmpVal > max )	{
				Beep( 300 );
				continue;
			}
			setstrng( EBuf, ' ', len );
			fswrite( EBuf, Row, Col, Attr3 );
			fswrite( wrkbuf, Row, Col, Attr3 );
			ESVQUIT = TRUE;
		}
		else
		if ( ch == TAB )  {
			TmpVal = atoi( wrkbuf );
			if ( TmpVal > max )	{
				Beep( 300 );
				continue;
			}
			setstrng( EBuf, ' ', len );
			fswrite( EBuf, Row, Col, Attr3 );
			fswrite( wrkbuf, Row, Col, Attr3 );
			ESVQUIT = TRUE;
		}
		else
		if ( ch == BS )  {			//  Backspace
			if ( SIdx == 0 )  {
				Beep( 250 );
				continue;
			}
			PRECCHG = TRUE;
			p = &wrkbuf[SIdx-1];
			pp = &wrkbuf[SIdx];
			while( *pp )  {
				*p++ = *pp++;
			}
			*p = '\0';
			fswrite( EBuf, Row, Col, Attr1 );
			fswrite( wrkbuf, Row, Col, Attr2 );
			SIdx -= 1;
			WrkCol -= 1;
		}
		else  {
			if ( INSMODE )  {
				if ( strlen( wrkbuf ) == len )  {
					Beep( 250 );
					continue;
				}
				strnset( buff, '\0', len );
				p = &wrkbuf[SIdx];
				pp = buff;
				while( *p ) {
					*pp++ = *p++;
				}
				wrkbuf[SIdx] = ch;
				SIdx += 1;
				pp = buff;
				p = &wrkbuf[SIdx];
				while( *pp )  {
					*p++ = *pp++;
				}
				WrkCol += 1;
				fswrite( wrkbuf, Row, Col, Attr2 );
				PRECCHG = TRUE;
			}
			else  {
				wrkbuf[SIdx] = ch;
				SIdx += 1;
				WrkCol += 1;
				fswrite( wrkbuf, Row, Col, Attr2 );
				PRECCHG = TRUE;
			}
		}
		gotoxy( WrkCol, Row );
	}	while( !ESVQUIT );

	p = &wrkbuf[strlen( wrkbuf ) -1]; 	//  Get rid
	while( *p == ' ') *p-- = '\0';	//  of trailing blanks

	( *Val ) = atoi( wrkbuf );
	if ( INSMODE )  {
		INSMODE = FALSE;
		er.h.ah = 0x01;
		er.h.ch = 0x06;
		er.h.cl = 0x07;
		int86( 0x10, &er, &er );
	}
	CursorOff();
	return;
}


/*-----------------------------------------------------------------------
------------------------------------------------------------------------*/

void EditHexValue( char *strng, unsigned int len, unsigned int Row,
			unsigned int Col, char *EBuf,
			unsigned int Attr1, unsigned int Attr2,
			unsigned int Attr3 )
{
	union REGS	er;
	int 		EHVQUIT = FALSE;
	int 		INSMODE = FALSE;
	unsigned int 	SIdx;
	unsigned int 	WrkCol;
	int		i;
	int		j;
	int		ch;
	int		key;
	int		loc;
	char 		*p;
	char		*pp;
	char 		*GoodHex="0123456789ABCDEF";

	DisplayCmdLine( 2 );
	CursorOn();
	fswrite( EBuf, Row, Col, Attr1 );
	fswrite( strng, Row, Col, Attr2 );
	SIdx = strlen( strng );
	WrkCol = Col + strln( strng );
	gotoxy( WrkCol, Row );
	do	{
		kbflush();
		if ( SIdx == len )  {
			SIdx = 0;
			WrkCol = Col;
			gotoxy( WrkCol, Row );
		}
		WaitForKeyPress();
		ch = getch();
		if ( ch == ESCAPE )  {        // Do nothing for this key.
			Beep( 250 );
			continue;
		}
		else
		if ( ch == SPECIALKEY )  {   //  Must get another key waiting
			key = getch();
			if ( key == HOME )  {
				SIdx = 0;
				WrkCol = Col;
			}
			else
			if ( key == END )  {
				SIdx = strln( strng );
				WrkCol = Col + ( strln( strng ) );
			}
			else
			if ( key == DELETE )  {
				p = &strng[SIdx];
				if ( !p )  {
					Beep( 250 );
					continue;
				}
				pp = &strng[SIdx+1];
				while( *pp )  {
					*p++ = *pp++;
				}
				*p = '\0';
				fswrite( EBuf, Row, Col, Attr1 );
				fswrite( strng, Row, Col, Attr2 );
			}
			if ( key == INS )  {               // Toggle insert mode
				if ( INSMODE )  {
					INSMODE = FALSE;
					er.h.ah = 0x01;
					er.h.ch = 0x06;
					er.h.cl = 0x07;
					int86( 0x10, &er, &er );
/*					fswrite("   ",25,75,Black+LightGrayBG);	*/
				}
				else  {
					INSMODE = TRUE;
					er.h.ah = 0x01;
					er.h.ch = 0x00;
					er.h.cl = 0x07;
					int86( 0x10, &er, &er );

/*					fswrite("INS",25,75,Yellow+BlueBG);	*/
				}
			}
			else
			if ( key == LEFT )  {		// Left arrow
				if ( SIdx == 0 )  {
					SIdx = ( strln( strng ) );
					WrkCol = Col + ( strln( strng ) );
				}
				else  {
					SIdx -= 1;
					WrkCol -= 1;
				}
			}
			else
			if ( key == RIGHT )  {		// Right arrow
				if ( SIdx == strln( strng ) )  {
					SIdx = 0;
					WrkCol = Col;
				}
				else  {
					SIdx += 1;
					WrkCol += 1;
				}
			}
		}
		else
		if ( ch == CR )  {
			if ( ( loc = strspn( strng, GoodHex ) ) != len )	{
					Beep( 600 );
					SIdx = loc;
					WrkCol = ( Col + loc );
					gotoxy( WrkCol, Row );
					continue;
			}
			else	{
				setstrng( EBuf, ' ', len );
				fswrite( EBuf, Row, Col, Attr3 );
				fswrite( strng, Row, Col, Attr3 );
				EHVQUIT = TRUE;
			}
		}
		else
		if ( ch == TAB )  {
			if ( ( loc = strspn( strng, GoodHex ) ) != len )	{
					Beep( 600 );
					SIdx = loc;
					WrkCol = ( Col + loc );
					gotoxy( WrkCol, Row );
					continue;
			}
			else	{
				setstrng( EBuf, ' ', len );
				fswrite( EBuf, Row, Col, Attr3 );
				fswrite( strng, Row, Col, Attr3 );
				EHVQUIT = TRUE;
			}
		}
		else
		if ( ch == BS )  {			//  Backspace
			if ( SIdx == 0 )  {
				Beep( 250 );
				continue;
			}
			p = &strng[SIdx-1];
			pp = &strng[SIdx];
			while( *pp )  {
				*p++ = *pp++;
			}
			*p = '\0';
			fswrite( EBuf, Row, Col, Attr1 );
			fswrite( strng, Row, Col, Attr2 );
			SIdx -= 1;
			WrkCol -= 1;
		}
		else  {
			if ( INSMODE )  {
				if ( strln( strng ) == len )  {
					Beep( 250 );
					continue;
				}
				p = buff;
				for( i = 0; i < len; i++ ) *p++ = '\0';
				p = &strng[SIdx];
				pp = buff;
				while( *p ) {
					*pp++ = *p++;
				}
				strng[SIdx] = toupper( ch );
				SIdx += 1;
				pp = buff;
				p = &strng[SIdx];
				while( *pp )  {
					*p++ = *pp++;
				}
				WrkCol += 1;
				fswrite( strng, Row, Col, Attr2 );
			}
			else  {
				strng[SIdx] = toupper( ch );
				SIdx += 1;
				WrkCol += 1;
				fswrite( strng, Row, Col, Attr2 );
			}
		}
		gotoxy( WrkCol, Row );
	}	while( !EHVQUIT );
	p = &strng[strln( strng ) -1]; 	//  Get rid
	while( *p == ' ') *p-- = '\0';	//  of trailing blanks
	p = &strng[strln( strng )];
	i = strln( strng );
	for ( j = i; j < len; j++ )
		*p++ = '\0';
	if ( INSMODE )  {
		INSMODE = FALSE;
		er.h.ah = 0x01;
		er.h.ch = 0x06;
		er.h.cl = 0x07;
		int86( 0x10, &er, &er );
	}
	CursorOff();
	return;
}