
/*-----------------------------------------------------------------------
   Module VIDEOLIB.H - Header file for VIDEOLIB.C

			Copyright (c) 1991-1993  Byron D Copeland
					All Rights Reserved.

------------------------------------------------------------------------*/

#define FALSE 0
#define TRUE (!FALSE)

char *C0={"                                      "};
//char *C1={"The Library used in this application is an UNREGISTERED "};
//char *C2={"COPY of FSVLIBL.LIB - Copyright (c) 1991-93  Byron D Copeland"};
//char *C3={"All rights Reserved.       "};
//char *C3A={"THIS IS AN ILLEGAL COPY!  THIS IS AN ILLEGAL COPY!"};
char *C3A={"THIS LIBRARY was written by Byron D Copeland"};
char *C3B={" Copyright (c) 1991-1993  Byron D Copeland All Rights Reserved."};
char *C6={"                                      "};

struct 	Wndw  {
   unsigned int 	Row;
   unsigned int 	Col;
   unsigned int 	Rows;
   unsigned int 	Cols;
   unsigned int 	Attr1;
   unsigned int 	Attr2;
   unsigned int 	Shdw;
   unsigned int 	BrdrTyp;
   char far 		*LastScrn;     /* Allocate n bytes to this variable to  */
			    /* Save the screen before  displaying    */
			    /* the window.                           */
			    /* Calculate:                            */
			    /* (Rows*Cols)*2 = bytes needed.         */
}  *WindowRec;

struct Wndw far 	*WindRec[1000];

/* No Border Structure.              */

struct 	Border0 	{
  char  	TBL[2];
  char  	LRS[2];
  char  	TLC[2];
  char  	TRC[2];
  char  	BLC[2];
  char  	BRC[2];
} Brdr0;

/*  Single-Line Border Structure.    */

struct 	Border1 	{
  char  	TBL[2];
  char  	LRS[2];
  char  	TLC[2];
  char  	TRC[2];
  char  	BLC[2];
  char  	BRC[2];
} Brdr1;

/*  Double-Line Border Structure.    */

struct 	Border2 	{
  char  	TBL[2];
  char  	LRS[2];
  char  	TLC[2];
  char  	TRC[2];
  char  	BLC[2];
  char  	BRC[2];
} Brdr2;


/*********************************************************************/
/*  Definitions used to remap Turbo C Colors.                        */
/*********************************************************************/

unsigned int Black;
unsigned int Blue;
unsigned int Green;
unsigned int Red;
unsigned int Brown;
unsigned int Magenta;
unsigned int Cyan;
unsigned int Gray;

unsigned int LightGray;
unsigned int LightBlue;
unsigned int LightGreen;
unsigned int LightRed;
unsigned int Yellow;
unsigned int LightMagenta;
unsigned int LightCyan;
unsigned int White;

unsigned int BlackBG;
unsigned int BlueBG;
unsigned int GreenBG;
unsigned int RedBG;
unsigned int BrownBG;
unsigned int MagentaBG;
unsigned int CyanBG;
unsigned int LightGrayBG;
unsigned int Blink;

unsigned int VidRows;
unsigned int VidCols;
unsigned int VidMode;
unsigned int ScreenSeg;

unsigned int Frame0;
unsigned int Frame1;
unsigned int Frame2;
unsigned int LastAttr;

char far * ScrnSave;
int CurrentWindow;
int VideoSeg;
int REGISTERED=0;
int WINLOOK;

unsigned int Shadow;
unsigned int NoShadow;
unsigned int VLastPos;

char *DT={"@@00/00/00@@"};

/*********************************************************************/
/*  Local Function Protypes.                                         */
/*********************************************************************/

int Init_FSVLib (void);

void fswrite (char *strng, unsigned int row, unsigned int column,
	       unsigned int attribute);

void fswchar (char schar, unsigned int row,
		  unsigned int column, unsigned int attribute);

void fswriteM (char * strng, unsigned int attribute);

void fswriteC (char * strng, unsigned int row, unsigned int column,
		unsigned int attribute);

void fsfill (unsigned int row, unsigned int column, unsigned int rows,
	      unsigned int columns, int fillchar, unsigned int attribute);

void fsattr (unsigned int row, unsigned int column, unsigned int rows,
	      unsigned int columns, unsigned int attribute);

int MakeWindow (unsigned int row, unsigned int col, unsigned int rows,
		  unsigned int cols, unsigned int Attr1, unsigned int Attr2,
		  unsigned int Shadow, unsigned int BType);

int ExplodeWindow (unsigned int row, unsigned int column, unsigned int rows, unsigned int columns,
			unsigned int attr1, unsigned int attr2, unsigned int Shadow,
			unsigned int BType);

void CloseWindow (void);
void SaveScreen (void);
void RestoreScreen (void);
void Boxit (unsigned int row, unsigned int column, unsigned int rows,
	     unsigned int columns, unsigned int attribute,
	     unsigned int BType);
void MakeButton( char *str, unsigned int Row, unsigned int Col,
		 unsigned int atr1, unsigned int atr2 );
void CursorOff (void);
void CursorOn (void);
