
/*-----------------------------------------------------------------------
   Modeule VIP7801.H - Header file used by VIP7801.C to
		      define all keys.

		Copyright (c) 1992-93  Byron D Copeland
			  All Rights Reserved.

------------------------------------------------------------------------*/

/*  Ascii Code Sequences for VIP7801 Emulation.  */

#define vipF01     "\033\060\0"        // F1  		ESC 0
#define vipF02     "\033\062\0"        // F2         	ESC 2
#define vipF03     "\033\066\0"        // F3		ESC 6
#define vipF04     "\033\070\0"        // F4		ESC 8
#define vipF05     "\033\072\0"        // F5		ESC :
#define vipF06     "\033\074\0"        // F6		ESC <
#define vipF07     "\033\076\0"        // F7		ESC >
#define vipF08     "\033\120\0"        // F8		ESC P
#define vipF09     "\033\122\0"        // F9		ESC R
#define vipF10     "\033\124\0"        // F10		ESC T
#define vipF11     "\033\134\0"        // F11		ESC \
#define vipF12     "\033\136\0"        // F12		ESC ^
#define vipFS01    "\033\061\0"        // FS01		ESC 1
#define vipFS02    "\033\065\0"        // FS02		ESC 5
#define vipFS03    "\033\067\0"        // FS03		ESC 7
#define vipFS04    "\033\071\0"        // FS04		ESC 9
#define vipFS05    "\033\073\0"        // FS05		ESC ;
#define vipFS06    "\033\075\0"        // FS06		ESC =
#define vipFS07    "\033\077\0"        // FS07		ESC ?
#define vipFS08    "\033\121\0"        // FS08		ESC Q
#define vipFS09    "\033\123\0"        // FS09		ESC S
#define vipFS10    "\033\126\0"        // FS10		ESC V
#define vipFS11    "\033\135\0"        // FS11		ESC ]
#define vipFS12    "\033\137\0"        // FS12		ESC _
#define vipFTAB     "\011\0"          	    // Field Tab
#define vipFBTAB    "\033\033OD\0"          // Field Back Tab
#define vipWTAB     "\033Op\033OC\0"        // Word Tab
#define vipWBTAB    "\033Op\033OD\0"        // Word Back Tab
#define vipWDEL     "\033Op\177\0"          // Word Delete
#define vipLEFT     "\033D\0"               // Cursor Left
#define vipRIGHT    "\033C\0"               // Cursor Right
#define vipUP       "\033A\0"               // Cursor Up
#define vipDN       "\033B\0"               // Cursor Down
#define vipEEOF     "\033\113\0"            // Erase EOF
#define vipEEOP     "\033\112\0"	    // Erase EOP
#define vipDEL      "\033\133\120\0"        // Character Delete
#define vipINS      "\033\133\111\0"        // Insert Mode
#define vipINSR     "\033\133\112\0"        // Insert Mode Reset
#define vipHOME     "\033\110\0"	    // Cursor Home
#define vipXMITA    "\033t\0"		    // Transmit All
#define vipXMITD    "\033i\0"	  	    // Transmit Data
