/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			 All Rights Reserved.
		---------------------------------------

*/

/*  Keyboard Code Sequences for ANSI Emulation.  */

#define anF01    "\033[M\0"            // F1
#define anF02    "\033[N\0"            // F2
#define anF03    "\033[O\0"            // F3
#define anF04    "\033[P\0"            // F4
#define anF05    "\033[Q\0"            // F5
#define anF06    "\033[R\0"            // F6
#define anF07    "\033[S\0"            // F7
#define anF08    "\033[T\0"            // F8
#define anF09    "\033[U\0"            // F9
#define anF10    "\033[V\0"            // F10
#define anF11    "\033[W\0"            // F11
#define anF12    "\033[X\0"            // F12

#define anSF01    "\033[Y\0"            // Shift F1
#define anSF02    "\033[Z\0"            // Shift F2
#define anSF03    "\033[a\0"            // Shift F3
#define anSF04    "\033[b\0"            // Shift F4
#define anSF05    "\033[c\0"            // Shift F5
#define anSF06    "\033[d\0"            // Shift F6
#define anSF07    "\033[e\0"            // Shift F7
#define anSF08    "\033[f\0"            // Shift F8
#define anSF09    "\033[g\0"            // Shift F9
#define anSF10    "\033[h\0"            // Shift F10
#define anSF11    "\033[i\0"            // Shift F11
#define anSF12    "\033[j\0"            // Shift F12

#define anCF01    "\033[k\0"            // Control F1
#define anCF02    "\033[l\0"            // Control F2
#define anCF03    "\033[m\0"            // Control F3
#define anCF04    "\033[n\0"            // Control F4
#define anCF05    "\033[o\0"            // Control F5
#define anCF06    "\033[p\0"            // Control F6
#define anCF07    "\033[q\0"            // Control F7
#define anCF08    "\033[r\0"            // Control F8
#define anCF09    "\033[s\0"            // Control F9
#define anCF10    "\033[t\0"            // Control F10
#define anCF11    "\033[u\0"            // Control F11
#define anCF12    "\033[v\0"            // Control F12

#define anAF01    "\033[w\0"            // Alt F1
#define anAF02    "\033[x\0"            // Alt F2
#define anAF03    "\033[y\0"            // Alt F3
#define anAF04    "\033[z\0"            // Alt F4
#define anAF05    "\033[@\0"            // Alt F5
#define anAF06    "\033[[\0"            // Alt F6
#define anAF07    "\033[\\\0"           // Alt F7
#define anAF08    "\033[]\0"            // Alt F8
#define anAF09    "\033[^\0"            // Alt F9
#define anAF10    "\033[_\0"            // Alt F10

// Unknowns

#define anAF11    "\033[u\0"            // Alt F11
#define anAF12    "\033[v\0"            // Alt F12

#define anHOME     "\033[H\0"              // HOME
#define anLEFT     "\033[D\0"              // Cursor Left
#define anRIGHT    "\033[C\0"              // Cursor Right
#define anUP       "\033[A\0"              // Cursor Up
#define anDN       "\033[B\0"              // Cursor Down
#define anEND      "\033[F\0"              // END
#define anINS      "\033[L\0"              // Toggle Insert Mode
#define anPGUP	   "\033[I\0"
#define anPGDOWN   "\033[G\0"
