#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <dos.h>
#include <dir.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <string.h>

#define Msg1 " BLDHELP v1.0 -01/26/1993- PowerTerm Help Txt/Idx File Builder.\n"
char Msg11[]={"* Copyright (c) 1992-93  Byron D Copeland  All Rights Reserved.\n"};
char Msg12[]={"Released for free use to all Military and D.O.D. offices and"\
	     " Employees.\n"};
char Msg13[]={"Individuals rights to free use terminates upon leaving"\
	     " Government Service.\n"};
#define INFILE "HELPDATA.IMP"
#define IDXFILE "IPCHELP.IDX"
#define HLPFILE "IPCHELP.TXT"

struct HlpIdx {
      char Htag[12];
      unsigned long recno;
      unsigned int  numrecs;
} HlpIdxRec;

struct HlpTxt {
  char TxtLine[65];
} HlpTxtRec;

FILE *IMP;
FILE *HTXT;
FILE *HIdx;

char *p;
char inbuf[80];
char outbuf[80];
unsigned long repos=0L;
unsigned int  recnt=0;
int  bytesout;


void main()
{
  printf(Msg1);
  printf(Msg11);
/*  printf(Msg12);*/
/*  printf(Msg13);  */
  strset(HlpTxtRec.TxtLine,'\0');
  if ((IMP = fopen(INFILE,"r")) == NULL)  {
    printf("No %s file to convert.\n",INFILE);
    exit(1);
  }
  if ((HTXT = fopen(HLPFILE,"wb")) == NULL)  {
    printf("Can't open %s.\n",HLPFILE);
    exit(1);
  }
  if ((HIdx = fopen(IDXFILE,"wb")) == NULL)  {
    printf("Can't open %s.\n",IDXFILE);
    exit(1);
  }
  HlpIdxRec.recno = 0L;
  HlpIdxRec.numrecs = 0;
  strcpy(HlpIdxRec.Htag,"\0");
  while (!feof(IMP))  {
    fgets(inbuf,80,IMP);
    if (feof(IMP)) break;
    while((p=strchr(inbuf,'\t')) != NULL) *p=' ';
    while((p=strchr(inbuf,'\n')) != NULL) *p='\0';
    if(strlen(inbuf)>63)
      inbuf[63]='\0';
    p=inbuf;
    if ((p=strchr(inbuf,'@')) != NULL)  {
      p++;
      if (strstr(p,"END") != NULL)  {
	HlpIdxRec.recno = repos;
	HlpIdxRec.numrecs = recnt;
	if ((bytesout = fwrite(&HlpIdxRec,sizeof(struct HlpIdx),1,HIdx)) != 1)  {
	  printf("Error writing Help Index.\n");
	  exit(1);
	}
	repos = repos + (unsigned long)recnt;
	recnt = 0;
      }
      else  {
	while((p=strchr(inbuf,'\n')) != NULL) *p='\0';
	p=inbuf; p++;
	strcpy(HlpIdxRec.Htag,p);
      }
    }
    else  {
      strset(HlpTxtRec.TxtLine,'\0');
      strcpy(HlpTxtRec.TxtLine,inbuf);
      if ((bytesout = fwrite(&HlpTxtRec,sizeof(struct HlpTxt),1,HTXT)) != 1)  {
	printf("Error writing HelpText.\n");
	exit(1);
      }
      recnt = recnt + 1;
    }
  }
  fcloseall();
  printf("File %s converted ok.\n",INFILE);
}


