#include <stdio.h>
#include "fsvlib.h"

extern char *buff;

void DisplayCmdLine( unsigned int cmd );

void DisplayCmdLine( unsigned int cmd )
{
	fsfill( 25, 1, 1, 80, ' ', White+LightGrayBG );
	switch ( cmd ) {
	case 0:  	fswrite( " F1", 25, 1, Red+LightGrayBG );
			fswriteM( "-Help  ", Black+LightGrayBG );
			fswriteM( "Tab", Red+LightGrayBG );
			fswriteM( "-Next Menu  ", Black+LightGrayBG );
			sprintf(buff,"%c%c",24,25);
			fswriteM(buff,Red+LightGrayBG);
			fswriteM("-Highlight  ",Black+LightGrayBG);
//			fswriteM( "Up/Dn Arrow", Red+LightGrayBG );
//			fswriteM( "-Move Selector  ", Black+LightGrayBG );
			sprintf( buff, "%c%c%c", 17, 196, 217 );
			fswriteM( buff, Red+LightGrayBG );
			fswriteM( "-Select  ", Black+LightGrayBG );
			break;
	case 1:  	fswrite(" F1",25,1,Red+LightGrayBG);
			fswriteM("-Help  ",Black+LightGrayBG);
			fswriteM("F2",Red+LightGrayBG);
			fswriteM("-Defaults  ",Black+LightGrayBG);
			sprintf(buff,"%c%c",24,25);
			fswriteM(buff,Red+LightGrayBG);
			fswriteM("-Highlight  ",Black+LightGrayBG);
			sprintf(buff,"%c%c%c",17,196,217);
			fswriteM(buff,Red+LightGrayBG);
			fswriteM("-Change  ",Black+LightGrayBG);
			fswriteM("Esc",Red+LightGrayBG);
			fswriteM("-Done  ",Black+LightGrayBG);
			break;
	case 2:  	fswrite(" F1",25,1,Red+LightGrayBG);
			fswriteM("-Help  ",Black+LightGrayBG);
			sprintf(buff,"%c%c%c",17,196,217);
			fswriteM(buff,Red+LightGrayBG);
			fswriteM("-Finish Edit  ",Black+LightGrayBG);
			break;
	case 3:  	fswrite(" F1",25,1,Red+LightGrayBG);
			fswriteM("-Help  ",Black+LightGrayBG);
			fswriteM("A",Red+LightGrayBG);
			fswriteM("dd  ",Black+LightGrayBG);
			fswriteM("C",Red+LightGrayBG);
			fswriteM("onnect  ",Black+LightGrayBG);
			fswriteM( "D", Red+LightGrayBG );
			fswriteM( "ial  ",Black+LightGrayBG);
			fswriteM("E",Red+LightGrayBG);
			fswriteM("dit  ",Black+LightGrayBG);
			fswriteM("P",Red+LightGrayBG);
			fswriteM("urge  ",Black+LightGrayBG);
			fswriteM("DEL",Red+LightGrayBG);
			fswriteM("-Delete  ",Black+LightGrayBG);
			fswriteM("Esc",Red+LightGrayBG);
			fswriteM("-Exit  ",Black+LightGrayBG);
			break;
	case 4:  	fswrite(" F1",25,1,Red+LightGrayBG);
			fswriteM("-Help  ",Black+LightGrayBG);
			fswriteM("F2",Red+LightGrayBG);
			fswriteM("-List  ",Black+LightGrayBG);
			fswriteM("F3",Red+LightGrayBG);
			fswriteM("-Clear All  ",Black+LightGrayBG);
			fswriteM("F10",Red+LightGrayBG);
			fswriteM("-Save Changes  ",Black+LightGrayBG);
			sprintf( buff, "%c%c%c", 17, 196, 217 );
			fswriteM( buff, Red+LightGrayBG );
			fswriteM("-Change  ",Black+LightGrayBG);
			fswriteM("Esc",Red+LightGrayBG);
			fswriteM("-Quit  ",Black+LightGrayBG);
			break;
	case 5:  	fswrite(" F1",25,1,Red+LightGrayBG);
			fswriteM("-Help  ",Black+LightGrayBG);
			sprintf(buff,"%c%c",24,25);
			fswriteM(buff,Red+LightGrayBG);
			fswriteM("-Highlight  ",Black+LightGrayBG);
			sprintf(buff,"%c%c%c",17,196,217);
			fswriteM(buff,Red+LightGrayBG);
			fswriteM("-Accept  ",Black+LightGrayBG);
			fswriteM("Esc",Red+LightGrayBG);
			fswriteM("-Go Back",Black+LightGrayBG);
			break;

	case 6:
			fswriteC("DoubleClick Mouse on selection to accept",25,
				VidCols, Red+LightGrayBG );
			break;

	case 7:  	fswrite( " F1", 25, 1, Red+LightGrayBG );
			fswriteM( "-Help  ", Black+LightGrayBG );
			sprintf(buff,"%c%c",24,25);
			fswriteM(buff,Red+LightGrayBG);
			fswriteM("-Highlight  ",Black+LightGrayBG);
			sprintf( buff, "%c%c%c", 17, 196, 217 );
			fswriteM( buff, Red+LightGrayBG );
			fswriteM( "-Select  ", Black+LightGrayBG );
			fswriteM( "Esc", Red+LightGrayBG );
			fswriteM( "-Go Back", Black+LightGrayBG );
			break;

	case 8:

			fswriteC( "Click mouse button or press ESCAPE key", 25, 80, Red+LightGrayBG );
			break;

	case 9:  	fswrite( " F1", 25, 1, Red+LightGrayBG );
			fswriteM( "-Help  ", Black+LightGrayBG );
			sprintf(buff,"%c%c",24,25);
			fswriteM(buff,Red+LightGrayBG);
			fswriteM("-Highlight  ",Black+LightGrayBG);
			sprintf( buff, "%c%c%c", 17, 196, 217 );
			fswriteM( buff, Red+LightGrayBG );
			fswriteM( "-Select  ", Black+LightGrayBG );
			fswriteM( "Esc", Red+LightGrayBG );
			fswriteM( "-Quit  ", Black+LightGrayBG );
			fswriteM( "F10", Red+LightGrayBG );
			fswriteM( "-Save Record", Black+LightGrayBG );
			break;

	default:
		break;
  }
}