/********************************************************************/
/*  FSVLIB.H - External declarations used by the FSVLIBx.LIB        */
/*            Libraries.                                            */
/*  This header file should be included with all your programs      */
/*  that intend to use any of the video function calls              */
/*                                                                  */
/*  FSVLIBx.LIB's are Copyright (c) 1991-93  Byron D Copeland       */
/*                       All Rights Reserved.                       */
/*                                                                  */
/********************************************************************/

extern unsigned int Black;
extern unsigned int Blue;
extern unsigned int Green;
extern unsigned int Red;
extern unsigned int Brown;
extern unsigned int Magenta;
extern unsigned int Cyan;
extern unsigned int Gray;

extern unsigned int LightGray;
extern unsigned int LightBlue;
extern unsigned int LightGreen;
extern unsigned int LightRed;
extern unsigned int Yellow;
extern unsigned int LightMagenta;
extern unsigned int LightCyan;
extern unsigned int White;

extern unsigned int BlackBG;
extern unsigned int BlueBG;
extern unsigned int GreenBG;
extern unsigned int RedBG;
extern unsigned int BrownBG;
extern unsigned int MagentaBG;
extern unsigned int CyanBG;
extern unsigned int LightGrayBG;
extern unsigned int Blink;
extern unsigned int Shadow;
extern unsigned int NoShadow;
extern unsigned int Frame0;
extern unsigned int Frame1;
extern unsigned int Frame2;

/*  Miscellaneous */

extern unsigned int VidRows;
extern unsigned int VidCols;
extern int CurrentWindow;
extern unsigned int VidMode;
extern int VideoSeg;
extern unsigned int LastAttr;

/********************************************************************/