
/*
		---------------------------------------
		PowerTerm (c) 1992-94  Byron D Copeland
			 All Rights Reserved.
		---------------------------------------

*/

#include "sysinfo.h"
#include "mouse.h"

extern char 	*buff;
extern int	MouseInstalled;
extern int	timeleft;
extern int	M_event;
extern char	Serial_Number[13];


void SysInfo( void )
{
	int	OK;
	int	ch;

	ExplodeWindow (9, 10, 11, 60, LightCyan+BlackBG, LightCyan+BlackBG,
		Shadow, Frame1);
	fswriteC ("P o w e r T e r m",10,VidCols,Cyan+BlackBG);
	fswriteC ("C o m m u n i c a t i o n s",11,VidCols,
		LastAttr);
	fswriteC ("Version 0.04 (beta)",12,VidCols,LastAttr);
	fswriteC ("Copyright (c) 1992-94  Byron D Copeland",14,VidCols,
		LastAttr);
	fswriteC ("All Rights Reserved.",15,VidCols,LastAttr);
	fswriteC ("Compiled with Borland-C++ 2.0  8 Aug 94",17,VidCols,
		LastAttr );
	sprintf( buff, "Serial Number: %s", Serial_Number );
	fswriteC( buff, 19, VidCols, LastAttr );
	DisplayCmdLine( 8 );
	if (MouseInstalled)
		Mshow();
	OK = FALSE;
	do	{
		kbflush();
		switch ( WaitForEvent() )	{

			case CHAR_EVENT:

				switch( ch = toupper( getch() ))	{

					case ESCAPE:

						kbflush();
						OK = TRUE;
						break;

					default:

						break;
				}
				break;

/*			case MOUSE2BUTTON:
				OK = TRUE;
				break;*/

			case MOUSE1BUTTON:

				OK = TRUE;
				break;
			default:
				break;
		}
	}	while( !OK );
	if (MouseInstalled)
		Mhide();
	CloseWindow ();
}


void DisplayOpenInfo( void )
{
	ExplodeWindow (8, 10, 11, 60, LightCyan+BlackBG, LightCyan+BlackBG,
		Shadow, Frame1);
	fswriteC ("P o w e r T e r m",9,VidCols,Cyan+BlackBG);
	fswriteC ("C o m m u n i c a t i o n s",10,VidCols,
		LastAttr);
	fswriteC ("Version 0.04 (beta)",11,VidCols,LastAttr);
	fswriteC ("Copyright (c) 1992-94  Byron D Copeland",13,VidCols,
		LastAttr);
	fswriteC ("All Rights Reserved.",14,VidCols,LastAttr);
	fswriteC ("Compiled with Borland-C++ 2.0  8 Aug 94",16,VidCols,
		LastAttr);
	sprintf( buff, "Serial Number: %s", Serial_Number );
	fswriteC( buff, 18, VidCols, LastAttr );
	if ( MouseInstalled )
		Mshow();
	alarm( 3 );
	while( ( !fast_kbhit() ) && ( !( M_event & 0x02 ) ) && ( timeleft > 0 ) );
	alarm( 0 );
	if ( MouseInstalled )
		Mhide();
	CloseWindow();
}


void RegistrationInfo( void )
{
	int	OK;
	int	ch;

	ExplodeWindow (9, 10, 13, 60, LightCyan+BlackBG, LightCyan+BlackBG,
		Shadow, Frame1);
	fswriteC( "P o w e r T e r m", 10, VidCols, Cyan+BlackBG );
	fswriteC( "C o m m u n i c a t i o n s", 11, VidCols,
		LastAttr );
	fswriteC( "Registration Information",13,VidCols,LastAttr);
	fswriteC( "Please send $7.00 (US) check or money order to:",15,VidCols,
		LastAttr);
	fswrite( "Byron D Copeland", 16, 29, LastAttr );
	fswrite( "9114 Statesman Road", 17, 29, LastAttr );
	fswrite( "Fort Belvoir, VA 22060", 18, 29, LastAttr );
	fswriteC( "Thank you for your support!", 20, VidCols, LastAttr );
	DisplayCmdLine( 8 );
	if (MouseInstalled)
		Mshow();
	OK = FALSE;
	do	{
		kbflush();
		switch ( WaitForEvent() )	{
			case CHAR_EVENT:

				switch( ch = toupper( getch() ))	{

					case ESCAPE:

						kbflush();
						OK = TRUE;
						break;

					default:

						break;
				}
				break;

/*			case MOUSE2BUTTON:
				OK = TRUE;
				break;*/
			case MOUSE1BUTTON:
				OK = TRUE;
				break;
			default:
				break;
		}
	}	while( !OK );
	if (MouseInstalled)
		Mhide();
	CloseWindow ();

}



