
/*  Ascii Code Sequences for VT100 Emulation.  */

#define vtPFK01    "\033\061\0"            // PF1
#define vtPFK02    "\033\062\0"            // PF2
#define vtPFK03    "\033\063\0"            // PF3
#define vtPFK04    "\033\064\0"            // PF4
#define vtPFK05    "\033\065\0"            // PF5
#define vtPFK06    "\033\066\0"            // PF6
#define vtPFK07    "\033\067\0"            // PF7
#define vtPFK08    "\033\070\0"            // PF8
#define vtPFK09    "\033\071\0"            // PF9
#define vtPFK10    "\033\060\0"            // PF10
#define vtPFK11    "\033\055\0"            // PF11
#define vtPFK12    "\033\075\0"            // PF12
#define vtPFK13    "\033!\0"               // PF13
#define vtPFK14    "\033@\0"               // PF14
#define vtPFK15    "\033#\0"               // PF15
#define vtPFK16    "\033$\0"               // PF16
#define vtPFK17    "\033%\0"               // PF17
#define vtPFK18    "\033^\0"               // PF18
#define vtPFK19    "\033&\0"               // PF19
#define vtPFK20    "\033*\0"               // PF20
#define vtPFK21    "\033(\0"               // PF21
#define vtPFK22    "\033)\0"               // PF22
#define vtPFK23    "\033[\0"               // PF23
#define vtPFK24    "\033]\0"               // PF24
#define vtPA1      "\033OS\0"              // PA1
#define vtPA2      "\033\056\0"            // PA2
#define vtPA3      "\033Ol\0"              // PA3
#define vtFTAB     "\033\033OC\0"          // Field Tab
#define vtFBTAB    "\033\033OD\0"          // Field Back Tab
#define vtWTAB     "\033Op\033OC\0"        // Word Tab
#define vtWBTAB    "\033Op\033OD\0"        // Word Back Tab
#define vtWDEL     "\033Op\177\0"          // Word Delete
#define vtLEFT     "\033OD\0"              // Cursor Left
#define vtRIGHT    "\033OC\0"              // Cursor Right
#define vtUP       "\033OA\0"              // Cursor Up
#define vtDN       "\033OB\0"              // Cursor Down
#define vtEEOF     "\033\177\0"            // Erase EOF
#define vtDEL      "\177\0"                // Character Delete
#define vtINS      "\033On\0"              // Toggle Insert Mode
#define TekTab     "\011\0"
#define TekBTab    "\033\011\0"


#define MasterReset "\007\0"		   // Master Reset for most Emulations

